#include <stdlib.h>
#include <string.h>
#include "fileserv.h"

char *
catfile_n(char const *dir, size_t len, char const *file)
{
	size_t flen;
	char *res, *p;
	
	while (len > 0 && dir[len-1] == '/')
		len--;
	while (*file == '/')
		file++;
	flen = strlen(file);
	while (flen && file[flen-1] == '/')
		--flen;
	res = xmalloc(len + flen + 2);
	memcpy(res, dir, len);
	p = res + len;
	if (flen) {
		*p++ = '/';
		memcpy(p, file, flen);
		p += flen;
	}
	*p = 0;
	return res;
}

char *
catfile(char const *dir, char const *file)
{
	return catfile_n(dir, strlen(dir), file);
}
