typedef struct dirlsent {
	char *name;
	struct stat st;
	char const *type;
	STAILQ_ENTRY(dirlsent) next;
} DIRLSENT;

typedef struct dirls {
	size_t count;
	STAILQ_HEAD(, dirlsent) list;
} DIRLS;

void dirls_init(DIRLS *dirls);
void dirls_free(DIRLS *dirls);
int dirls_scan(DIRLS *dirls, char const *path, CONFIG const *conf);
void dirls_sort(DIRLS *dirls, INDEX_SORT_COL col, INDEX_SORT_ORD ord);

