#include <stdio.h>
#include <string.h>
#include "fileserv.h"

void
xmalloc_fail(void)
{
	error("not enough memory");
	exit(1);
}

void *
xmalloc(size_t s)
{
	void *p = malloc(s);
	if (!p)
		xmalloc_fail();
	return p;
}

void *
xcalloc(size_t nmemb, size_t size)
{
	char *ptr;
	if (size < SIZE_T_MAX / nmemb)
		ptr = calloc(nmemb, size);
	else
		ptr = NULL;
	if (!ptr)
		xmalloc_fail();
	return ptr;
}

void *
xnrealloc(void *ptr, size_t nmemb, size_t size)
{
	if (size < SIZE_T_MAX / nmemb)
		ptr = realloc(ptr, nmemb * size);
	else
		ptr = NULL;
	if (!ptr)
		xmalloc_fail();
	return ptr;
}

void *
xrealloc(void *ptr, size_t size)
{
	return xnrealloc(ptr, 1, size);
}

char *
xstrdup(char const *str)
{
	char *ptr = strdup(str);
	if (!ptr)
		xmalloc_fail();
	return ptr;
}

